<template>
    <div class="container mx-auto py-5">
        <h1 class="text-3xl font-bold text-left">Wyszukiwarka konwentów</h1>
        <input type="text" placeholder="Nazwa konwentu" class="input input-bordered w-full my-5" @input="searchHandler" v-model="query"/>
        <hr>
        <table class="table">
            <thead>
                <tr>
                    <th>Nazwa</th>
                    <th>Lokalizacja</th>
                    <th>Data</th>
                    <th></th>
                </tr>
            </thead>
            <tbody v-if="conList.length > 0">
                <tr v-for="con in conList" v-bind:key=con>
                    <td>
                    <div class="flex items-center gap-3">
                        <div class="avatar">
                        <div class="mask mask-squircle w-12 h-12">
                            <router-link :to="'/konwent/' + con.id">
                                <img src="https://gfx.dlastudenta.pl/photos/wiadomosci/Remcon_2024_logo.jpg"/>
                            </router-link>
                        </div>
                        </div>
                        <div class="font-bold">
                            <router-link :to="'/konwent/' + con.id">
                                {{ con.name }}
                            </router-link>
                        </div>
                    </div>
                    </td>
                    <td>{{ con.location || "Wypizdowie" }}</td>
                    <td>{{ parseDate(con.start_date) }}</td>
                    <th>
                    <button class="btn btn-ghost btn-xs" @click="showConPreview(con)">Pokaż więcej</button>
                    </th>
                </tr>
            </tbody>
        </table>
        <h3 v-if="!loaded">
            ładowanie wyników...
        </h3>
        <h3 class="text-center" v-if="conList.length == 0 && query.length != 0 && loaded">
            Nie znaleziono żadnych konwentów spełniających kryteria wyszukiwania :(
        </h3>
        <div class="drawer drawer-end" style="z-index: 9">
            <input id="showConPreviewDrawer" type="checkbox" class="drawer-toggle" />
            <div class="drawer-side">
                <label for="showConPreviewDrawer" aria-label="close sidebar" class="drawer-overlay"></label>
                <ul class="menu p-4 w-80 min-h-full bg-base-200 text-base-content" >
                    <h4 class="font-bold text-2xl">{{ showcasedCon.name }}</h4>
                    <div class="rounded-md m-4 shadow-lg bannerBox">
                        <img src="https://gfx.dlastudenta.pl/photos/wiadomosci/Remcon_2024_logo.jpg"/>
                    </div>
                    <button class="btn btn-primary" @click="$router.push(`/konwent/${showcasedCon.id}`)">
                        Pokaż pełne informacje...
                    </button>
                    <div class="rounded-md m-4 shadow-lg infoBox">
                        <h4 class="text-left font-bold">Krótki opis:</h4>
                        <p class="text-left">{{ showcasedCon.description || "Niestety nie mamy opisu tego konwentu, jeśli byłeś możesz dodać!" }}</p>
                    </div>
                    <div class="rounded-md m-4 shadow-lg infoBox text-left">
                        <p v-if="showcasedCon.start_date">Początek: {{ parseDate(showcasedCon.start_date) }}</p>
                        <p>Lokalizacja: {{ showcasedCon.location ||  "Wypizdowie"}}</p>
                        <p>Organizator: nie wiem ale baza ludzie imo</p>
                    </div>
                </ul>
            </div>
        </div>
    </div>
</template>
<script>
import apiCalls from '@/services/apiCalls.service';
import utils from '@/services/utils.service';

export default {
    data() {
        return {
            query: "",
            conList: [],
            loaded: true,
            showcasedCon: {}
        }
    },
    mounted(){
        this.searchCons()
        this.debouncedSearch = utils.debounce(function(){this.searchCons()}, 500)
    },
    methods: {
        searchHandler(){
            this.loaded = false;
            this.debouncedSearch()
        },
        searchCons(){
            if (this.query) {
                apiCalls.get(`api/v1/conventions/search/${this.query}`)
                .then(res => {
                    this.conList = res
                })
            } else {
                apiCalls.get('api/v1/conventions/')
                .then(res => {
                    this.conList = res
                })
            }
            this.loaded = true
        },
        showConPreview(con){
            apiCalls.get(`api/v1/conventions/${con.id}`)
                .then(res => {
                    this.showcasedCon = res
                })
            let checkbox = document.getElementById('showConPreviewDrawer')
            checkbox.checked = true
        },
        parseDate : utils.parseDate
    }
}
</script>